<?xml version="1.1" encoding="UTF-8" standalone="no"?>
<databaseChangeLog xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
                   xmlns:ext="http://www.liquibase.org/xml/ns/dbchangelog-ext"
                   xmlns:pro="http://www.liquibase.org/xml/ns/pro" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                   xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog-ext http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-ext.xsd http://www.liquibase.org/xml/ns/pro http://www.liquibase.org/xml/ns/pro/liquibase-pro-4.1.xsd http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-4.1.xsd">
    <changeSet author="Dima Subbotin (generated)" id="1629638486950-1">
        <createTable tableName="users">
            <column name="id" type="VARCHAR(255)">
                <constraints nullable="false" primaryKey="true" primaryKeyName="users_pkey"/>
            </column>
            <column name="login" type="VARCHAR(255)">
                <constraints nullable="false"/>
            </column>
            <column name="password_hash" type="VARCHAR(255)">
                <constraints nullable="false"/>
            </column>
            <column name="email" type="VARCHAR(255)"/>
            <column name="role" type="VARCHAR(255)">
                <constraints nullable="false"/>
            </column>
            <column name="first_name" type="VARCHAR(255)"/>
            <column name="last_name" type="VARCHAR(255)"/>
            <column name="middle_name" type="VARCHAR(255)"/>
            <column defaultValueBoolean="false" name="locked" type="BOOLEAN">
                <constraints nullable="false"/>
            </column>
        </createTable>
    </changeSet>
    <changeSet author="Dima Subbotin (generated)" id="1629638486950-2">
        <createTable tableName="projects">
            <column name="id" type="VARCHAR(255)">
                <constraints nullable="false" primaryKey="true" primaryKeyName="projects_pkey"/>
            </column>
            <column name="name" type="VARCHAR(255)">
                <constraints nullable="false"/>
            </column>
            <column name="description" type="VARCHAR(255)"/>
            <column defaultValue="NOT_STARTED" name="status" type="VARCHAR(255)">
                <constraints nullable="false"/>
            </column>
            <column defaultValueComputed="CURRENT_TIMESTAMP" name="create_date" type="TIMESTAMP WITHOUT TIME ZONE">
                <constraints nullable="false"/>
            </column>
            <column name="start_date" type="TIMESTAMP WITHOUT TIME ZONE"/>
            <column name="user_id" type="VARCHAR(255)">
                <constraints nullable="false"/>
            </column>
        </createTable>
    </changeSet>
    <changeSet author="Dima Subbotin (generated)" id="1629638486950-3">
        <createTable tableName="tasks">
            <column name="id" type="VARCHAR(255)">
                <constraints nullable="false" primaryKey="true" primaryKeyName="tasks_pkey"/>
            </column>
            <column name="name" type="VARCHAR(255)">
                <constraints nullable="false"/>
            </column>
            <column name="description" type="VARCHAR(255)"/>
            <column defaultValue="NOT_STARTED" name="status" type="VARCHAR(255)">
                <constraints nullable="false"/>
            </column>
            <column defaultValueComputed="CURRENT_TIMESTAMP" name="create_date" type="TIMESTAMP WITHOUT TIME ZONE">
                <constraints nullable="false"/>
            </column>
            <column name="start_date" type="TIMESTAMP WITHOUT TIME ZONE"/>
            <column name="project_id" type="VARCHAR(255)"/>
            <column name="user_id" type="VARCHAR(255)">
                <constraints nullable="false"/>
            </column>
        </createTable>
    </changeSet>
    <changeSet author="Dima Subbotin (generated)" id="1629638486950-4">
        <createTable tableName="sessions">
            <column name="id" type="VARCHAR(255)">
                <constraints nullable="false" primaryKey="true" primaryKeyName="session_pkey"/>
            </column>
            <column defaultValueComputed="CURRENT_TIMESTAMP" name="date" type="TIMESTAMP WITHOUT TIME ZONE">
                <constraints nullable="false"/>
            </column>
            <column name="signature" type="VARCHAR(255)"/>
            <column name="user_id" type="VARCHAR(255)">
                <constraints nullable="false"/>
            </column>
        </createTable>
    </changeSet>
    <changeSet author="Dima Subbotin (generated)" id="1629638486950-5">
        <addForeignKeyConstraint baseColumnNames="user_id" baseTableName="projects" constraintName="projects_fk"
                                 deferrable="false" initiallyDeferred="false" onDelete="NO ACTION" onUpdate="NO ACTION"
                                 referencedColumnNames="id" referencedTableName="users" validate="true"/>
    </changeSet>
    <changeSet author="Dima Subbotin (generated)" id="1629638486950-6">
        <addForeignKeyConstraint baseColumnNames="user_id" baseTableName="sessions" constraintName="session_fk"
                                 deferrable="false" initiallyDeferred="false" onDelete="NO ACTION" onUpdate="NO ACTION"
                                 referencedColumnNames="id" referencedTableName="users" validate="true"/>
    </changeSet>
    <changeSet author="Dima Subbotin (generated)" id="1629638486950-7">
        <addForeignKeyConstraint baseColumnNames="user_id" baseTableName="tasks" constraintName="tasks_fk"
                                 deferrable="false" initiallyDeferred="false" onDelete="NO ACTION" onUpdate="NO ACTION"
                                 referencedColumnNames="id" referencedTableName="users" validate="true"/>
    </changeSet>
    <changeSet author="Dima Subbotin (generated)" id="1629638486950-8">
        <addUniqueConstraint columnNames="email" constraintName="users_email_key" tableName="users"/>
    </changeSet>
    <changeSet author="Dima Subbotin (generated)" id="1629638486950-9">
        <addUniqueConstraint columnNames="login" constraintName="users_login_key" tableName="users"/>
    </changeSet>
    <changeSet author="Dima Subbotin (generated)" id="1629638486950-10">
        <addForeignKeyConstraint baseColumnNames="project_id" baseTableName="tasks" constraintName="tasks_fk1"
                                 deferrable="false" initiallyDeferred="false" onDelete="NO ACTION" onUpdate="NO ACTION"
                                 referencedColumnNames="id" referencedTableName="projects" validate="true"/>
    </changeSet>
</databaseChangeLog>
